/*
         xdipo copyright Jan Panteltje 2005 and later.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/


                                  /* SET TABS TO 4 TO READ THIS SOURCE */


/* BEEP.C */

#include "xdipo.h"
//#include <asm/io.h>


int beep(int duration, int freq)
{
long i;
long lt;
int scale;

if(freq == 0) return 1;
if(duration == 0) return 1;
scale = 1193046 / freq;
outb(0xb6, 0x43);
outb(scale & 0xff, 0x42);
outb(scale >> 8, 0x42);
outb(inb(0x61) | 3, 0x61); /* set bit 0 and 1, timer 2 gate and lsp gate */

lt = duration * 6666666; /* depends on system speed */
for(i = 0; i < lt; i++) /* delay */
	{
	;
	}

outb(inb(0x61) & ~3, 0x61); /* reset bit 0 and 1, timer 2 gate and lsp gate */
return 1;
}


int sbeep(int milliseconds, int freq) /* short beep */
{
long i;
long lt;
int scale;

if(freq == 0) return 1;
if(milliseconds == 0) return 1;
scale = 1193046 / freq;
outb(0xb6, 0x43);
outb(scale & 0xff, 0x42);
outb(scale >> 8, 0x42);
outb(inb(0x61) | 3, 0x61); /* set bit 0 and 1, timer 2 gate and lsp gate */
lt = milliseconds * 6666; /* depends on system speed */
for(i = 0; i < lt; i++) /* delay */
	{
	;
	}
outb(inb(0x61) & ~3, 0x61); /* reset bit 0 and 1, timer 2 gate and lsp gate */

return 1;
} /* end function sbeep */


int beep_freq(int freq) /* set frequency of beep */
{
int scale;
if(freq == 0) return 1;

scale = 1193046 / freq;

outb(0xb6, 0x43);
outb(scale & 0xff, 0x42);
outb(scale >> 8, 0x42);

return 1;
}


void beep_on()
{
outb(inb(0x61) | 3, 0x61);/*set bit 0 and 1, timer 2 gate and lsp gate */
}


void beep_off()
{
outb(inb(0x61) & ~3, 0x61);/*reset bit 0 and 1, timer 2 gate and lsp gate */
}

