/*
         xdipo copyright Jan Panteltje 2005 and later.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/


                                  /* SET TABS TO 4 TO READ THIS SOURCE */


#include "xdipo.h"

FD_xdipo *fdui;

int test_for_open_forms(int *some_form_open_flag)
{
*some_form_open_flag = 0;

if(timer_form_shown_flag) 
	{
	fl_show_alert("Close timer form first (use ACCEPT)", "", "", 1);
	*some_form_open_flag = 1;
	}

return 1;
}/* end function test_for_open_forms */


int recalculate_and_fill_in_fields()
{
char direction[10];
char temp[80];

if(debug_flag)
	{
	fprintf(stderr,\
	"recalculate_and_fill_in_fields():arg none, using longitude=%.2f latitude=%.2f satellite_position=%.2f\n",\
	longitude, latitude, satellite_position);
	}

if(! calculate_angle_and_elevation(longitude, latitude, satellite_position, &calculated_angle, &elevation) )
	{
	fl_show_alert("satellite below horizon", "", "", 0);

	return 0;
	}

if(calculated_angle < 0.0)
	{
	direction[0] = 'E';
	}
else
	{
	direction[0] = 'W';
	}
direction[1] = 0;

sprintf(temp, "%.2f %s", fabs(calculated_angle), direction);
fl_set_input(fdui -> main_form_angle_input_field, temp);

sprintf(temp, "%.2f", elevation);
fl_set_object_label(fdui -> main_form_elevation_output_field, temp);

return 1;
} /* end function recalculate_and_fill_in_fields */
 

int load_local_position()
{
FILE *fptr;
char temp[4096];
char direction[10];

if(debug_flag)
	{
	fprintf(stderr, "load_local_position(): ar none\n");
	}

sprintf(temp, "%s/.xdipo/latitude", home_dir);
fptr = fopen(temp, "r");
if(! fptr)
	{
	if(debug_flag)
		{
		fprintf(stderr, "load_local_position(): could not open file %s for read\n", temp);
		}

	return 0;
	}
fscanf(fptr, "%lf", &latitude);
fclose(fptr);

if(latitude < 0.0)
	{
	direction[0] = 'S';
	}
else
	{
	direction[0] = 'N';
	}
direction[1] = 0;

sprintf(temp, "%.2f %s", fabs(latitude), direction);
fl_set_input(fdui -> main_form_latitude_input_field, temp);


sprintf(temp, "%s/.xdipo/longitude", home_dir);
fptr = fopen(temp, "r");
if(! fptr)
	{
	if(debug_flag)
		{
		fprintf(stderr, "load_local_position(): could not open file %s for read\n", temp);
		}

	return 0;
	}
fscanf(fptr, "%lf", &longitude);
fclose(fptr);

if(longitude < 0.0)
	{
	direction[0] = 'E';
	}
else
	{
	direction[0] = 'W';
	}
direction[1] = 0;

sprintf(temp, "%.3f %s", fabs(longitude), direction);
fl_set_input(fdui -> main_form_longitude_input_field, temp);

return 1;
} /* end function load_local_position */


int select_stream(int browser_line)
{
int a, i;
char temp[80];
struct program *pa;

if(debug_flag)
	{
	fprintf(stderr, "select_stream(): browser_line=%d\n", browser_line);
	}

/* argument check */
if(browser_line < 0) return 0;

/* find the entry in the linked list */
for(pa = programtab[0]; pa != 0; pa = pa -> nxtentr)	
	{
	if(pa -> browser_line == browser_line)
		{
		angle = pa -> angle;
		satellite_number = pa -> satellite;
		frequency = pa -> frequency;
		polarization = pa -> polarization;
		symbolrate = pa -> symbolrate;
			
		/* set input fields */
		sprintf(temp, "%d", satellite_number);
		fl_set_input(fdui -> main_form_satellite_number_input_field, temp);
		fl_set_input(fdui -> installer_commands_form_satellite_number_input_field, temp);

		sprintf(temp, "%.2f", frequency);
		fl_set_input(fdui -> main_form_frequency_input_field, temp);

		sprintf(temp, "%c", polarization);
		fl_set_input(fdui -> main_form_polarization_input_field, temp);

		sprintf(temp, "%d", symbolrate);
		fl_set_input(fdui -> main_form_symbolrate_input_field, temp);

		fl_set_input(fdui -> main_form_satellite_name_input_field, pa -> satellite_name);

		if(angle < 0) a = 'E';
		else a = 'W';
		sprintf(temp, "%.2f %c", fabs(pa -> angle), a);
		fl_set_input(fdui -> main_form_angle_input_field, temp);

		if(pa -> gw_angle < 0) a = 'E';
		else a = 'W';
		sprintf(temp, "%.2f %c", fabs(pa -> gw_angle), a);		
		fl_set_input(fdui -> main_form_satellite_location_input_field, temp);

		/* replace any '_' in pids with spaces */
		i = 0;
		while(1)
			{
			pids_string[i] = pa -> pids[i];

			if(pids_string[i] == 0) break;
			if(pids_string[i] == '_') pids_string[i] = ' ';

			i++;
			}
	
		fl_set_input(fdui -> main_form_pids_input_field, pids_string);

		/* parse pids_string */
		if(! parse_pids_string(pids_string) )
			{
			fl_show_alert("could not parse pids_string", "command cancelled", "", 0);

			return 0;
			}

		return 1;
		}
	} /* end for all entries in list */

return 0;
} /* end function select_program */


int delete_program_line(int selected_program)
{
struct program *pa;

if(debug_flag)
	{
	fprintf(stderr, "delete_program(): arg selected_program=%d\n",\
	selected_program);
	}

if(selected_program < 0) return 0;

/* find the entry in the linked list */
for(pa = programtab[0]; pa != 0; pa = pa -> nxtentr)	
	{
	if(pa -> browser_line == selected_program)
		{
		delete_program(pa -> name);

		return 1;
		}
	} /* end for all entries in list */

/* not found */
return 0;
} /* end function delete_program_line */


void main_form_recorder_menu_cb(FL_OBJECT *ob, long data)
{
main_form_recorder_menu_selection = fl_get_menu(ob);

/* if nothing selected, but mouse in menu, no action */
if(main_form_recorder_menu_selection <= 0) return;

if(main_form_recorder_menu_selection == RECORDER_MENU_TIMERS)
    {
	clear_timer_form();

    show_timer_form();

    return;
    }      

} /* end function main_form_recorder_menu_cb */



void main_form_pids_input_field_cb(FL_OBJECT *ob, long data)
{
char *ptr;

if(debug_flag)
	{
	fprintf(stderr, "main_form_pids_input_field_cb():\n");
	}

ptr = (char *) fl_get_input(ob);
if(! ptr) return;

strncpy(pids_string, ptr, 79);

if(! parse_pids_string(pids_string) )
	{
	fl_show_alert("could not parse pids", "", "", 0);

	return;
	}

return;
} /* end function main_form_pids_input_field_cb */


void main_form_seek_slider_cb(FL_OBJECT *ob, long data)
{
//seek_position = (uint64_t)play_length * fl_get_slider_value(ob);

//seek_flag = 1;
}/* end function main_form_seek_slider_cb */


void main_form_record_button_cb(FL_OBJECT *ob, long data)
{
char *ptr, *ptr2;
FILE *fptr;
char temp[4096];
int selected_line;

if(debug_flag)
	{
	fprintf(stderr, "main_form_record_button_cb(): arg none\n");
	}

if( fl_get_button(ob) )
	{
	selected_line = fl_get_browser(fdui -> main_form_stream_browser);
	if(! selected_line)
		{
		fl_show_alert("Select an entry with middle mouse first" ,"in the browser", "", 0);		

		fl_set_button(ob, 0);
		
		return;
		}

	selected_stream = abs(selected_line);

	/* select stream */
	if(! select_stream( selected_stream ) )
		{
		fl_show_alert("Select an entry with middle mouse first" ,"in the browser", "", 0);		

		fl_set_button(ob, 0);
		
		return;
		}
	
	/* and move the dish to the sat or angle */
	main_form_goto_button_cb(0, 0);

	ptr = (char *) fl_show_fselector("Select output filename", output_dir, "*.ts", output_filename);
	if(! ptr)
		{
		fl_set_button(ob, 0);

		return;
		}
	
	if(output_dir) free(output_dir);
	output_dir = strsave(ptr);
	if(! output_dir)
		{
		fprintf(stderr,\
		"xdipo: main_form_record_button_cb(): could not allocate space for output_dir, aborting\n");

		exit(1);
		}

	/* cut of the filename part */
	ptr2 = strrchr(output_dir, '/');
	if(ptr2) *ptr2 = 0;

	/* save for later program restart */
	sprintf(temp, "%s/.xdipo/output_dir", home_dir);
	fptr = fopen(temp, "w");
	if(! fptr)
		{
		fl_show_alert("could not open file %s for write", "output directory name not saved", "", 0);
		}
	else
		{	
		fprintf(fptr, "%s", output_dir); 
		fclose(fptr);	
		}

	if(output_filename) free(output_filename);
	output_filename = strsave(ptr);
	if(! output_filename)
		{
		fprintf(stderr,\
"xdipo: main_form_output_filename_input_field_cb(): could not allocate space for output_filename, aborting\n");

		exit(1);	
		}
	
	/* test if file perhaps already exists */
	ofptr = fopen(output_filename, "r");
	if(ofptr)
		{
		fclose(ofptr);

		sprintf(temp, "File %s already exists, overwrite?", output_filename);
		if(!fl_show_question(temp, 0) ) /* mouse on no */
			{
			fl_set_button(ob, 0);

			return;
			}
		}

	if(! open_output_files() )
		{
		return;
		}

	set_record_button(1);

	recording_start_time = time(NULL);

	recorder_mode = RECORDER_RECORD_MODE;
	recorder_mode |= RECORDER_MAN_RECORD_MODE;	// indicate we are recording manually, not from timers, timer need to know this when releasing record button for stop..
	}
else /* released record button = stop */
	{
	if(! fl_show_question("recording is in progress, abort?", 0) ) /* mouse on no */
		{
		fl_set_button(ob, 1);

		return;
		}

	/* test if user abort from main form record button */
	if(recorder_mode & RECORDER_MAN_RECORD_MODE)
		{
		/* if stopping manually started recording leave the timers unchanged */ 			

		close_output_files();

		recorder_mode = RECORDER_STOP_MODE;
		}
	else
		{	
		recorder_mode = RECORDER_ABORT_MODE; // timers and record loop will see this, and close files, then change to RECODER_STOP_MODE.	
		}

	set_record_button(0);

	/* enable all controls on all forms again, if it not already */
	enable_controls(1);
	}

} /* end function main_form_record_button_cb */


void main_form_satellite_name_input_field_cb(FL_OBJECT *ob, long data)
{
char *ptr, *ptr2;

if(debug_flag)
	{
	fprintf(stderr, "main_form_satellite_name_input_field_cb(): arg none\n");
	}

ptr = (char *)fl_get_input(ob);
if(! ptr) return;

if(strchr(ptr, ' ') != 0)
	{
	fl_show_alert("No spaces allowed in satellite name", "replaced spaces with '_'", "", 0);

	ptr2 = ptr;	
	while(1)
		{
		if(! *ptr2) break;

		if(*ptr2 == ' ') *ptr2 = '_';
	
		ptr2++;
		}

	fl_set_input(ob, ptr);

	return;
	}

} /* end function main_form_satellite_name_input_field_cb */


void main_form_satellite_location_input_field_cb(FL_OBJECT *ob, long data)
{
int a;
char *ptr;
char direction[10];
double degrees;

if(debug_flag)
	{
	fprintf(stderr, "main_form_satellite_location_input_field_cb(): arg none\n");
	}

ptr = (char *) fl_get_input(ob);
if(! ptr) return;

a = sscanf(ptr, "%lf %1[EW]s", &degrees, direction);
if(a != 2)
	{
	fl_show_alert("Usage 23.12 E or 76.93 W", "space required", "", 0);

	return;
	}

if(direction[0] == 'E') degrees *= -1.0;

satellite_position = degrees;

if(debug_flag)
	{
	fprintf(stderr,\
	"main_form_satellite_location_input_field_cb(): satellite_position=%.2f\n", satellite_position);
	}

recalculate_and_fill_in_fields();

} /* end function main_form_satellite_location_input_field_cb */


void main_form_longitude_input_field_cb(FL_OBJECT *ob, long data)
{
int a;
char *ptr;
char direction[10];
double degrees;
FILE *fptr;
char temp[4096];

if(debug_flag)
	{
	fprintf(stderr, "main_form_satellite_location_input_field_cb(): arg none\n");
	}

ptr = (char *) fl_get_input(ob);
if(! ptr) return;

a = sscanf(ptr, "%lf %1[EW]s", &degrees, direction);
if(a != 2)
	{
	fl_show_alert("Usage 23.12 E or 76.93 W", "space required", "", 0);

	return;
	}

if(direction[0] == 'E') degrees *= -1.0;

longitude = degrees;

if(debug_flag)
	{
	fprintf(stderr,\
	"main_form_longitude_input_field_cb(): longitude=%.3f\n", longitude);
	}

sprintf(temp, "%s/.xdipo/longitude", home_dir);
fptr = fopen(temp, "w");
if(! fptr)
	{
	fl_show_alert("could not open file", temp, "for write", 0);

	return;
	}
fprintf(fptr, "%.3f\n", longitude); 
fclose(fptr);

recalculate_and_fill_in_fields();

} /* end function main_form_longitude_input_field_cb */


void main_form_latitude_input_field_cb(FL_OBJECT *ob, long data)
{
int a;
char *ptr;
char direction[10];
double degrees;
FILE *fptr;
char temp[4096];

if(debug_flag)
	{
	fprintf(stderr, "main_form_satellite_location_input_field_cb(): arg none\n");
	}

ptr = (char *) fl_get_input(ob);
if(! ptr) return;

a = sscanf(ptr, "%lf %1[NS]s", &degrees, direction);
if(a != 2)
	{
	fl_show_alert("Usage 23.12 N or 76.93 S", "space required", "", 0);

	return;
	}

if(direction[0] == 'S') degrees *= -1.0;

latitude = degrees;

if(debug_flag)
	{
	fprintf(stderr,\
	"main_form_latitude_input_field_cb(): latitude=%.3f\n", latitude);
	}

sprintf(temp, "%s/.xdipo/latitude", home_dir);
fptr = fopen(temp, "w");
if(! fptr)
	{
	fl_show_alert("could not open file", temp, "for write", 0);

	return;
	}
fprintf(fptr, "%.3f\n", latitude); 
fclose(fptr);

recalculate_and_fill_in_fields();

} /* end function main_form_latitude_input_field_cb */


void main_form_toggle_goto_angle_sattelite_button_cb(FL_OBJECT *ob, long data)
{
int a;

a = fl_get_button(ob);
if(a)
	{
	goto_mode = GOTO_SATELLITE;
	fl_set_object_label(fdui -> main_form_goto_button, "GOTO\nSAT NR");
	}
else
	{
	goto_mode = GOTO_ANGLE;
	fl_set_object_label(fdui -> main_form_goto_button, "GOTO\nANGLE");
	}

} /* end function main_form_toggle_goto_angle_sattelite_button_cb */


void main_form_angle_input_field_cb(FL_OBJECT *ob, long data)
{
char *ptr;

ptr = (char *) fl_get_input(ob);
if(! ptr) return;


goto_angular_position(ptr);

} /* end function main_form_angle_input_field_cb */


void main_form_angle_down_button_cb(FL_OBJECT *ob, long data)
{
int a;
char *ptr;
char direction[10];
double degrees;
char temp[80];

if(debug_flag)
	{
	fprintf(stderr, "main_form_angle_down_button_cb(): arg none\n");
	}

ptr = (char *) fl_get_input(fdui -> main_form_angle_input_field);
if(! ptr) return;

a = sscanf(ptr, "%lf %1[EW]s", &degrees, direction);
if(a != 2)
	{
	fl_show_alert("Usage 23.12 E or 76.93 W", "space required", "", 0);
	return;
	}

angle -= 0.5;

if(angle < 0.0)
	{
	direction[0] = 'E';
	}
else
	{
	direction[0] = 'W';
	}
direction[1] = 0;

sprintf(temp, "%.2f %s", fabs(angle), direction);
fl_set_input(fdui -> main_form_angle_input_field, temp);

fl_redraw_object(fdui -> main_form_angle_input_field);

goto_angular_position(temp);

} /* end function main_form_angle_down_button_cb */


void main_form_angle_up_button_cb(FL_OBJECT *ob, long data)
{
int a;
char *ptr;
char direction[10];
double degrees;
char temp[80];

if(debug_flag)
	{
	fprintf(stderr, "main_form_angle_up_button_cb(): arg none\n");
	}

ptr = (char *) fl_get_input(fdui -> main_form_angle_input_field);
if(! ptr) return;

a = sscanf(ptr, "%lf %1[EW]s", &degrees, direction);
if(a != 2)
	{
	fl_show_alert("Usage 23.12 E or 76.93 W", "space required", "", 0);
	return;
	}

angle += 0.5;

if(angle < 0.0)
	{
	direction[0] = 'E';
	}
else
	{
	direction[0] = 'W';
	}
direction[1] = 0;

sprintf(temp, "%.2f %s", fabs(angle), direction);
fl_set_input(fdui -> main_form_angle_input_field, temp);

fl_redraw_object(fdui -> main_form_angle_input_field);

goto_angular_position(temp);

} /* end function main_form_angle_up_button_cb */


void main_form_add_stream_button_cb(FL_OBJECT *ob, long data)
{
//int s_line;

/* add the entry to the browser */
if(! add_program_in_position() ) return;

show_programs(SHOW_SAME_POSITION);

/* mark new entry in browser */
//program_to_line(selected_program, &s_line);

//fl_select_browser_line(fdui -> main_form_stream_browser, s_line);

save_programs();
} /* end function main_form_add_stream_button_cb */


void main_form_delete_stream_button_cb(FL_OBJECT *ob, long data)
{
int total_lines;
int s_line;

if(! fl_show_question("DELETE this entry?", 0) ) return; /* mouse on NO */

total_lines = fl_get_browser_maxline(fdui -> main_form_stream_browser);
for(s_line = 1; s_line <= total_lines; s_line++)
	{
	if(fl_isselected_browser_line(fdui -> main_form_stream_browser, s_line) )
		{
		/* finally delete structure entry */
		delete_program_line(s_line);

		/* write modified structure list to disk */
		save_programs();

		/* only one at the time */
		break;		
		}/* end selected line */
	}/* end for all lines */

show_programs(SHOW_SAME_POSITION);

/* keep entry visible */
//fl_set_browser_topline(fdui -> main_form_stream_browser, selected_program - 10);

} /* end function main_form_delete_stream_button_cb */


void main_form_signal_strength_slider_cb(FL_OBJECT *ob, long data)
{
} /* end function main_form_signal_strength_slider_cb */


void main_form_stream_browser_cb(FL_OBJECT *ob, long data)
{
int selected_line;
int mouse_button;
char temp[80];

if(debug_flag)
	{
	fprintf(stderr, "main_form_stream_browser_cb():\n");
	}

mouse_button = fl_mouse_button();

selected_line = fl_get_browser(ob);
if(! selected_line) return;

if(mouse_button == FL_LEFT_MOUSE)
	{
	selected_stream = abs(selected_line);

	/* select stream */
	if(! select_stream(selected_stream) ) return;
	}
else if(mouse_button == FL_RIGHT_MOUSE)
	{
	add_timer_to_list(selected_line);

	return;
	}
else if(mouse_button == FL_MIDDLE_MOUSE)
	{
	selected_stream = abs(selected_line);

	/* select stream */
	if(! select_stream(selected_stream) ) return;
	
	/* and move the dish to the sat or angle */
	main_form_goto_button_cb(0, 0);

	return;
	}

/* save o.a. selected_program */
//save_general_settings();

sprintf(temp, "%d", selected_stream);
save_setting("selected_stream", temp);

} /* end function main_form_stream_browser_cb */


void main_form_stream_browser_double_cb(FL_OBJECT *ob, long data)
{
return;
} /* end function main_form_stream_browser_double_cb */


void main_form_installer_button_cb(FL_OBJECT *ob, long data)
{
show_installer_commands_form();
} /* end function main_form_installer_button_cb */


void main_form_frequency_input_field_cb(FL_OBJECT *ob, long data)
{
char *ptr;

ptr = (char *) fl_get_input(ob);
if(! ptr) return;

sscanf(ptr, "%lf", &frequency);
} /* end function main_form_frequency_input_field_cb */


void main_form_polarization_field_cb(FL_OBJECT *ob, long data)
{
char *ptr;

ptr = (char *) fl_get_input(ob);
if(! ptr) return;
if( (ptr[0] != 'h') && (ptr[0] != 'v') ) return;

polarization = ptr[0];

} /* end function main_form_polarization_field_cb */


void main_form_symbolrate_input_field_cb(FL_OBJECT *ob, long data)
{
char *ptr;

ptr = (char *) fl_get_input(ob);
if(! ptr) return;

sscanf(ptr, "%i", &symbolrate);
} /* end function main_form_symbolrate_input_field_cb */


void main_form_signal_strength_indicator_cb(FL_OBJECT *ob, long data)
{

} /* end function main_form_signal_strength_indicator_cb */


void main_form_beep_button_cb(FL_OBJECT *ob, long data)
{
if(! root_flag)
	{
	fl_show_alert("To use the beep function you need to be root", "but you are", user_name, 0);

	fl_set_button(ob, 0);

	return;
	}

beep_mode = fl_get_button(ob);

if(beep_mode)
	{
	beep_on();
	}
else
	{
	beep_off();
	}

} /* end function main_form_beep_button_cb */


void main_form_step_value_input_field_cb(FL_OBJECT *ob, long data)
{
int a;
char *ptr;

ptr = (char *) fl_get_input(ob);
if(! ptr) return;

sscanf(ptr, "%i", &a);

nudge_size = (int8_t)a;

} /* end function main_form_step_value_input_field_cb */


void main_form_satellite_number_input_field_cb(FL_OBJECT *ob, long data)
{
char *ptr;
char temp[80];

ptr = (char *)fl_get_input(ob);
if(! ptr) return;

sscanf(ptr, "%i", &satellite_number);

sprintf(temp, "%d", satellite_number);
fl_set_input(fdui -> installer_commands_form_satellite_number_input_field, temp);

} /* end function main_form_satellite_number_input_field_cb */


void main_form_nudge_motor_west_button_cb(FL_OBJECT *ob, long data)
{
int temp[]={0xe0, 0x31, 0x69, 0x00};

// low
//int temp[]={0xe0, 0x11, 0x20};
//send_diseqc_command(temp, 3);
//return;

if(step_time_mode == STEP_MODE) temp[3] = nudge_size;
else temp[3] = 256 - nudge_size;

send_diseqc_command(temp, 4);

} /* end function main_form_nudge_motor_west_button_cb */


void main_form_nudge_motor_east_button_cb(FL_OBJECT *ob, long data)
{
int temp[]={0xe0, 0x31, 0x68, 0x00};

// high
//int temp[]={0xe0, 0x11, 0x24};
//send_diseqc_command(temp, 3);
//return;

if(step_time_mode == STEP_MODE) temp[3] = nudge_size;
else temp[3] = 256 - nudge_size;

send_diseqc_command(temp, 4);

} /* end function main_form_nudge_motor_east_button_cb */


void main_form_nudge_tilt_motor_up_button_cb(FL_OBJECT *ob, long data)
{
int temp[]={0xe0, 0x32, 0x68, 0x00};

if(step_time_mode == STEP_MODE) temp[3] = nudge_size;
else temp[3] = 256 - nudge_size;

send_diseqc_command(temp, 4);

} /* end function main_form_nudge_tilt_motor_up_button_cb */


void main_form_nudge_tilt_motor_down_button_cb(FL_OBJECT *ob, long data)
{
int temp[]={0xe0, 0x32, 0x69, 0x00};

if(step_time_mode == STEP_MODE) temp[3] = nudge_size;
else temp[3] = 256 - nudge_size;

send_diseqc_command(temp, 4);

} /* end function main_form_nudge_tilt_motor_down_button_cb */


void main_form_increase_nudge_size_button_cb(FL_OBJECT *ob, long data)
{
char temp[80];

if(nudge_size < 127) nudge_size++;

sprintf(temp, "%d", abs(nudge_size) );
fl_set_input(fdui -> main_form_step_value_input_field, temp);

} /* end function main_form_increase_nudge_size_button_cb */


void main_form_decrease_nudge_size_button_cb(FL_OBJECT *ob, long data)
{
char temp[80];

if(nudge_size > -127) nudge_size--;

sprintf(temp, "%d", abs(nudge_size) );
fl_set_input(fdui -> main_form_step_value_input_field, temp);

} /* end function main_form_decrease_nudge_size_button_cb */


void main_form_toggle_step_timed_mode_button_cb(FL_OBJECT *ob, long data)
{
int a;
char temp[80];

a = fl_get_button(ob);

if(a)
	{
	step_time_mode = STEP_MODE;
	fl_set_object_label(ob, "STEP\nMODE");
	fl_set_object_color(ob, FL_COL1, FL_YELLOW);
	fl_set_object_label(fdui -> main_form_step_value_input_field, "step size");
	}
else
	{
	step_time_mode = TIME_MODE;
	fl_set_object_label(ob, "TIME\nMODE");
	fl_set_object_color(ob, FL_COL1, FL_COL1);
	fl_set_object_label(fdui -> main_form_step_value_input_field, "timeout");
	}

//nudge_size = 256 - nudge_size;

sprintf(temp, "%d", abs(nudge_size) );
fl_set_input(fdui -> main_form_step_value_input_field, temp);

} /* end function main_form_toggle_step_timed_mode_button_cb */


void main_form_store_present_satellite_number_button_cb(FL_OBJECT *ob, long data)
{
int temp[]={0xe0, 0x31, 0x6a, 0x00};

if(! fl_show_question("Store present satellite number?", 0) ) return; /* mouse on NO */

temp[3] = satellite_number;

send_diseqc_command(temp, 4);

} /* end function main_form_store_present_satellite_number_button_cb */


void main_form_goto_button_cb(FL_OBJECT *ob, long data)
{
char *ptr;
int temp[]={0xe0, 0x31, 0x6b, 0x00};

/* also if no ENTER pressed in main_form_satellite_number_input_field ? */
 ptr = (char *)fl_get_input(fdui -> main_form_satellite_number_input_field);
 if(! ptr) return;

 satellite_number = atoi(ptr);

if(goto_mode == GOTO_SATELLITE)
	{
	temp[3] = satellite_number;

	send_diseqc_command(temp, 4);
	}
else // goto angle
	{
	main_form_angle_input_field_cb(fdui -> main_form_angle_input_field, 0);
	}
} /* end function main_form_goto_button_cb */


void main_form_increment_satellite_number_button_cb(FL_OBJECT *ob, long data)
{
char temp[80];

if(satellite_number < 255) satellite_number++;

sprintf(temp, "%d", satellite_number);
fl_set_input(fdui -> main_form_satellite_number_input_field, temp);
fl_set_input(fdui -> installer_commands_form_satellite_number_input_field, temp);
} /* end function main_form_increment_satellite_number_button_cb */


void main_form_decrement_satellite_number_button_cb(FL_OBJECT *ob, long data)
{
char temp[80];

if(satellite_number > 0) satellite_number--;

sprintf(temp, "%d", satellite_number);
fl_set_input(fdui -> main_form_satellite_number_input_field, temp);
fl_set_input(fdui -> installer_commands_form_satellite_number_input_field, temp);
} /* end function main_form_decrement_satellite_number_button_cb */


void main_form_exit_switch_cb(FL_OBJECT *ob, long data)
{
char temp[80];

/* test if any forms are open */

if(! test_for_open_forms(&some_form_open_flag) ) return;
if(some_form_open_flag) return;

if(beep_mode) beep_off();

/* this will create the files in ~/.xdipo/setup/ so xdipo will not report them missing again the second time it is started */

sprintf(temp, "%d", selected_stream);
save_setting("selected_stream", temp);
save_fontsizes();
save_search_settings();

exit(0);
} /* end function main_form_exit_switch_cb */


int set_record_button(int state)
{
if(debug_flag)
	{
	fprintf(stderr, "set_record_button(): arg state =%d\n", state);
	}

fl_set_button(fdui -> main_form_record_button, state);

if(state)
	{
	fl_set_object_label(fdui -> main_form_output_filename_output_field, output_filename);
	fl_set_object_color(fdui -> main_form_output_filename_output_field, FL_RED, FL_COL1);
	fl_set_object_label(fdui -> main_form_record_button, "STOP");
	}
else
	{
	fl_set_object_label(fdui -> main_form_record_button, "RECORD");
	fl_set_object_color(fdui -> main_form_output_filename_output_field, FL_YELLOW, FL_COL1);
	fl_set_object_label(fdui -> main_form_output_filename_output_field, output_dir);
	}


return 1;
} /* end function set_record_button */


void main_form_search_input_field_cb(FL_OBJECT *ob, long data)
{
if(debug_flag)
	{
	fprintf(stderr, "main_form_search_input_field_cb()\n");
	}

save_search_settings();
} /* end function main_form_search_input_field_cb */


void main_form_search_button_cb(FL_OBJECT *ob, long data)
{
search_and_select_satellite();
} /* end function main_form_search_button_cb */


void main_form_case_sensitive_button_cb(FL_OBJECT *ob, long data)
{
if(debug_flag)
	{
	fprintf(stderr, "main_form_case_sensitive_button_cb()\n");
	}

save_search_settings();
} /* end functon main_form_case_sensitive_button_cb */


void main_form_fontsize_up_button_cb(FL_OBJECT *ob, long data)
{
int size;

if(main_form_fontsize < 5) main_form_fontsize++;
size = integer_to_fontsize(main_form_fontsize);

fl_set_browser_fontsize(fdui -> main_form_stream_browser, size);

save_fontsizes();
}/* end function main_form_fontsize_up_button_cb */



void main_form_fontsize_down_button_cb(FL_OBJECT *ob, long data)
{
int size;

if(main_form_fontsize > 0) main_form_fontsize--;
size = integer_to_fontsize(main_form_fontsize);

fl_set_browser_fontsize(fdui -> main_form_stream_browser, size);

save_fontsizes();
}/* end function main_form_fontsize_down_button_cb */


