                              Manual xdipo-0.7.9


                      xdipo copyright 2005 and later Jan Panteltje
                            xdipo is released under the GPL		




         Attention, command line flags have changed since 0.4.1, do a xdipo -h for more info.



xdipo (X Dish Positioner) is a tool to help you set up a Diseqc (tm) 1.2 compatible satellite dish.

It also support the 'goto angle' command, as implemented in some positioners.
xdipo is developed testing on a Moteck SG 2100A positioner.

             Kernel modification (2.4.xxx and 2.6.xxx):
 To use xdipo for viewing or make recordings with it, it is NEEDED to modify the Linux DVB driver:

 If you have the kernel sources installed:

 Modify /usr/src/linux//drivers/media/dvb/dvb-core/dmxdev.h so it reads:
    "#define DVR_BUFFER_SIZE (100*188*1024) // (original 10*188*1024)

 Next do
 make modules_install

 Now either reboot or reload the dvbcore module.

 Theory behind this:
 When recording a full transponder stream (xdipo option -a 8192), and 40 Mbits / second = 5 MByte / second,
 the DVB driver writes 5 MByte in one second to the kernel buffer.
 The application in 'user space' (xdipo) must be able to read and empty this buffer to prevent buffer overflow
 (loss of data).
 So if for any reason (for example swapping IO, heavy system load) xdipo CANNOT read data for 1 second, then
 there will be 5 MByte in the dvr buffer.
 Convergence.de specifies a size of 10 x 188 x 1024 = 1.925 MByte.......
 So the maximum 'out time' allowed is only 380 milli seconds.
 I have reported this to DVB the driver developer list years ago, nothing was changed.
 So the slower (and lots of these things run on cheap boxes) the PC, the bigger the buffer needs to be.
 That is why I increased the data buffer to 10x the original size.
 Programs like dvbstream do not seem to check for 'buffer overflow' and just ignore it, meaning your
 recording will have errors, and editing will become a problem.
 This version of xdipo will report these errors and ask you to increase buffer size.
             end kernel modification


xdipo -h will give you some help.

There are basically 2 modes:

1 script mode: 
You can type

./xdipo -g "25 E"
xdipo will use the goto command, steer the dish to 25 east on the positioner scale, and exit.
No GUI is created.

xdipo -b 12
will steer the dish to satellite number 12 as programmed in the positioner, then exit. No GUI.

xdipo -w
will remove power and switch off the 22 kHz tone to positioner and LNB, then exit. No GUI.

xdipo -q
will send the 'stop' command, halting any motion in progress, then exit. No GUI.

xdipo -v -b 18  -f 10773 -p h -s 22000 -o | jpinfo -p  6301 | mplayer -cache 8192  -vop pp=0x20000 -
will steer the dish to satellite 18 (Astra2 as stored in the positioner), then display it in mplayer. No GUI.
If you do not have jpinfo then try this perhaps:
xdipo -v -b 18  -f 10773 -p h -s 22000 -o | ts2pes 2304 2306 | mplayer -cache 8192  -vop pp=0x20000 -
or
xdipo -g "19 E"  -f 10773 -p h -s 22000 -o | ts2pes 2304 2306 | mplayer -cache 8192  -vop pp=0x20000 -
ts2pes from convergence driver 0.9.3 or 0.9.4....

Or record a whole transponder from Astra2 (about 10GB / hour in this case):
xdipo -g "28.2 E" -f 10773 -p h -s 22000 -o > /video/all_bbc_programs.ts

Play it back later, or time shifted at the same time:
cat all_bbc_programs.ts | jpinfo -p  6301 | mplayer -cache 8192  -vop pp=0x20000 -
cat all_bbc_programs.ts | ts2pes 2304 2306 | mplayer -cache 8192  -vop pp=0x20000 -

This will wait 10 seconds while moving the dish to Astra1, then play BBC 1 (2304=VPOD 2306=APID).
xdipo -c 10 -o -a "2304 2306" -g "28.2  E" -f 10773 -p h -s 22000 | mplayer -cache 8192 -vop pp=0x20000 -

Same, record BBC1 only (adapt angle "28.2 E". for your location).
xdipo -c 10 -o -a "2304 2306" -g "28.2  E" -f 10773 -p h -s 22000 > bbc1.ts

You can find jpinfo here:
 http://panteltje.com/panteltje/satellite/jpinfo-0.1.tgz 
jpinfo is similar to jpcam but has no decryption.

2 GUI mode:
just type
xdipo
A GUI with indicators will pop up, I have tried to be Diseqc-1.2 compatible.
You can set sat name, sat angular position, sat number, transponder frequency, polarization, and symbolrate.
You can save these settings, they go in /root/.xdipo/streams.dat

When using the GUI, enter a satellite name, satellite number, angle (real angle, as indicated on the
positioner), frequency, polarization, symbolrate.
Also enter the PIDS you want to record from the stream.
Or, you can enter the service ID, first type a 's' then a space, then the service ID number in the PIDs field.
Only one service ID is allowed.
Then press the 'add' button.

When using a service ID, xdipo pipes the output via the program 'jpinfo', that must be installed.

Pressing GOTO ANGLE (or GOT SAT NR) tunes to the selected transponder, and then moves the dish to
the specified angle (or sat nr).
Changing a value in the angle input field, and then pressing ENTER will also move the dish.
STORE will store the current position in the selected sat nr (in the positioner).
Please read the docs/positioner_appli_notice.pdf for more info on Diseqc-1.2 commands.

To use such an entry, left click mouse on it, then press the GOTO ANGLE button.
If you press the bottom left button marked 'ANGLE / SAT NR' so it is yellow, then the text in the
GOTO ANGLE button changes to GOTO SAT.
When you press GOTO SAT then the dish will move to the satellite number, as stored in the positioner.

BEEP:
There is an audio beep mode, I use this with my PC mike in front of the PC speaker and the speakers
in the window, so when outside I can hear what happens when working on the dish.
You can only use the beep function if you are root, as this uses direct IO to the PC timer.
If the beep stays on after exiting xdipo in an other way then the EXIT button, try backspace, that
will sound the beep too, and then switch it off.

Absolute positioning:
The little angle increment and decrement buttons change the angle input field, and move the dish to
the absolute angle as indicated on the positioner.
Very useful for seeking max signal / best signal to noise.
When maximum found, press 'add' and the setting is stored.
Make sure you have the right sat number in the center input field, and correct frequency, polarization,
and symbolrate.
Later you can then select that entry and press GOTO.

Calculator:
You can enter your position in the longitude and latitude input fields.
The position is saved if you exit the program.
Next enter a satellite position in the 'satellite location' input.
Enter the satellite name too.
When pressing ENTER the elevation will appear in the yellow 'elevation' field.
The calculated angle will be filled in in the angle east/west input field (top left).
To force calculation CHANGE something in either longitude, latitude, or position input field, then hit ENTER.
Select a transponder frequency, polarization, and symbolrate (and perhaps a sat number, look up your
positioner docs).
Press GOTO ANGLE (bottom middle).
Look at the signal strength, fine adjust position with the 2 little buttons under east/west (top left).
When max signal, press 'add' button.
Now the entry appears in the stream browser.
You can, if you want to correct your positioner's internal satellite table entry for this satellite number,
press STORE (bottom middle).

Search:
You can enter a text in the field to the left of the Search button, then press Search.
This will select the first browser entry containing that text.
Pressing Search again will find the next browser entry.
If no more matching entries are found, a popup will warn you.
The search can be made case sensitive by pressing the Case sens button.


It is also possible to have the positioner recalculate all satellite positions, using 'recalculate positions'
from the installer form.
You can enter decimal values or 0x1A like hex values.
So far I have had good results with that, with the Moteck SG 2100 A.
Even had to power it down (xdipo -o) to get it working again....
Maybe I did something wrong.
Storing individual satellite numbers works.
This will need more testing, read the pdf in docs/, especially the appication note.
Unfortunately Moteck does not provide data on commands.

Saving streams:
1 select a satellite, adjust for max signal.
2 press the OUTPUT button, enter a filename.
Thats is it.
Press OUTPUT again to stop.

Fontsizes:
Both the main form and the timer form have little '+' and '-' buttons to set the browser fontsize.
The changes made by those in the timer form are only remembered when 'Accept' is pressed,
those in the main form stream browser are always remembered after a restart.


PIDS input field:
Normally 8192 is displayed here, this passes all pids in the transponder stream.
You can specify up to 16 pids here in deciomal, then PRESS ENTER.
Only pressing the ENTER key will make a change.
Do not do this while recording.....
Or, you can enter the service ID, first type a 's' then a space, then the service ID number in the PIDs field.
Only one service ID is allowed.
Then press the 'add' button.
You can also in script mode specify pids with -a "4416 4417 4418" for example,
or one service ID with -a "s 10072".
When using a service ID, xdipo pipes the output via the program 'jpinfo', that must be installed.

Timers:
   Recording to disk using the timers:
Press RIGHT mouse button on a program in the main form stream list.
The timer form pops up. with the timers (latest one last).
Colors:
TIMER WAITING     black
TIMER_EXPIRED     dark green bold
TIMER_RUNNING     blue 
TIMER_OVERLAP     red
TIMER_ERROR       magenta

Select a timer with the LEFT mouse.
Now you can modifiy the times (it is preset to the current time).
Set start and end time.
If some timers overlap they will appear red.
You CANNOT press ACCEPT in the timer form if some timers overlap.
Timers will not start while the timer form is open!

If you press DAILY or WEEKLY the selected timer will, after it stopped,
create an updated entry a day or a week later.
(And a new recording filename will be used with the new date).
Pressing WORK DAYS should skip saturdays and sundays, so on friday set
the next recording day to monday.

NOTE:
 xdipo must be running for the daily or weekly update to happen, if not
 then the timer will be 'old' and will not run next time you start xdipo!

A length field shows the length of the recording, you can use this
as an input too, then it modifies the stop year / month/day/minute/second
for you.

Added Showview in / output, but I need more info on that system, so it does
not work yet.

Things SHOULD also work OK if summer time / winter time change happens,
and also in a leap year, but not tested very much yet.
(For the C programmers this code is in update_time_and_filename() in
timer_form.c).

If OK press ACCEPT
If you press CANCEL, the timer for will be restored to the old values.

Now all you have to do is wait.
When a recording starts, all buttons except the OUTPUT / STOP button are
disabled, to prevent you from interfering with the recording.
When the recording is finished, xdipo will stay on that station.

You can cancel a running timer with the STOP(= OUTPUT) button in the main form.
If a timer starts when you are already recording in the main form, then it cancels itself.
As long as the timer form is open a timer cannot start.
For timers to work xdipo must be running in GUI mode.
You also can use xdipo in script mode from crontab, just use full path filenames.
xdipo uses no threads, just xforms idle callback.

Before a timer starts recording it first instructs the positioner to steer the dish to the satellite
position, then waits 10 seconds and tunes to the transponder.
The filename outout field will be orange and inform you during these 10 seconds.
You can also abort recoding by pressing stop in that period.



One way to use xdipo from a script would be like this (after having properly set up the dish):

# this script moves the dish to 13 East on the positioner scale (hotbird) and plays visions Europe
interlaced.
xdipo -g "13 E"
dvbstream -f 12092 -p v -s 27500 -ps -o 4416 4417 | mplayer -cache 8192 -vop pp=0x20000 -
Note that you should use the correct angle for your location.


Or, if encrypted, and teletext:

rm ~/jpcam_pids
rm /video/vtx/1/*
xdipo -g "19 E"
dvbstream -f 11131 -p v -s 5632 -o 8192 | 
/video/compile/pantel/jpvtx/jpvtx | \
/video/compile/pantel/jpcam/jpcam -p 5001 | \
xine -D -

Then start teletext viewer xvtx-p to view the teletext.


If you want to be on the safe side, in case the dish hits an obstruction, try perhaps:
# script move_to_hotbird
# move to 13 East, exact angle depends on your latitude and longitude.
xdipo -g "8.6 E"
# wait for the motion to complete
sleep 10
# send the 'halt' command.
xdipo -s

Then you can do:
move_to_hotbird
dvbstream -f 12092 -p v -s 27500 -ps -o 4416 4417 | mplayer -cache 8192 -vop pp=0x20000 -

without having to worry that the disk motor is still running. 

An example of a better solution is in the included 'goto' script.
In case your dish is not aligned exactly, you can fix it in that script too.
You should edit the angles for your location.
For example 19 E (Astra1) is only 19 East if you are on the Greenwich meridian. 
If you 'walk' 19 degrees east, then 19 E is at 0 degrees, straight south for you.
Try this link: http://www.satlex.de/en/azel_calc-first_1.html for an on line calculator.


Problems:
If you get errors like 'Value too large for defined data type' when using /dev/dvb/adapter0/dvr0
with cat, then a solution in my case is to increase the dvr buffer in the DVB driver dmxdev.h.
old:
#define DVR_BUFFER_SIZE (10*188*1024)
I changed it to:
#define DVR_BUFFER_SIZE (100*188*1024)
and then recompiled / reloaded the driver modules.
The problem only happens when you use HUGE data streams,
for example astra2 10773.00 h the whole transponder
(all BBC channels etc..).
In this case the buffer overflows....
The data rate here I estimate at about 36 Mbps (16 GB / hour),
and this may happen on HDTV too.
So maybe the DVR buffer size default should be a bit bigger then what it now is.
One can also solve the problem by setting
update -1 1000
update -5 100
(see man bdflush or update --help)
This empties the buffer more often.
But bigger buffer is better I think.
These errors may be caused by high bandwidth streams or high system loads.
For example recording all BBC channels on 10773.00 H on Astra2, is about 10GB / hour.
On my Duron 950 I need to set 'update -5 100' and 'update -1 1000' and be careful not to load
the system too much if I do not patch the driver.
The default on my system is 500 and 3000 (check with 'update -d' on your system).
You can set it back after the recording is finished with 'update 5 3000' and 'update -1 500' for example.
For more info on 'update' do a 'man bdflush' and 'update --help'.

Positioner does not move:
If the positioner sometimes does not move, it is possible that the PCI card LNB power supply
cannot deliver enough current.
For this reason I have set the voltage to 13 V (and not 18) as using high voltage causes the
LNB power supply on my wintv nova to current limit?
This needs some more research.
You can see if the commands are send, xdipo shows the commands in the status output field.
I have looked up some LNB power chips, and most of these use a step up converter to make the LNB
voltage from the 12 V.
They draw more current if you specify 18 V output, so that MAY explain it.

A solution would be an external LNB power supply, maybe I will design a simple (cheapo) one.
(You need a 24 V DC 500mA supply, emitter follower, 2 PCB female F connectors, one cap, 1 RF choke,
as a first estimate, run TV card output voltage via resistor into base of emmittor follower, emittor of
that via RF choke (stop 22 kHz AND 1-2GHz) to dish.
Input from card via cap to dish.
Just a first estimate what it would take, maybe overlooked something).


Key bindings:
 main form: move east is '[' or '{', move west is ']' or '}'. 
 installer form: move east = 'E' or 'e', move west is 'W' or 'w', halt = 'H' or 'h'.
 Mouse scroll wheel scrolls in main form stream browser.
 Left mouse in browser selects and fills in input fields only.
 Middle mouse in main form stream browser selects, fills in input fields, and moves to satellite or position.
 Right mouse in main form stream browser pops up timer form.
 Timer form browser: use left mouse.

files:
/root/.xdipo/streams.dat
/root/.xdipo/longitude
/root/.xdipo/latitude
/root/.xdipo/output_dir
/root/.xdipo/disk_space
/root/.xdipo/angle
/root/.xdipo/xdipo.xpm
/root/.xdipo/timers.dat
/root/.xdipo/setup/fontsizes
/root/.xdipo/setup/search_settings
/root/.xdipo/setup/selected_stream


More examples:
Example script for recording multichannel from Hotbird 13 E, with bit error logging, using jpcam:
(If you do not use jpcam, specify all pids where it now says 8192).

# free up DVB
killall -KILL xdipo

serial_number=`/bin/cat /reiser/video/in/serial.txt`
/bin/echo "serial_number=$serial_number"

#SkyStar2 xdipo
xdipo \
-l /reiser/video/in/vie-$serial_number-bit-errors.txt \
-g "19.0 E" \
-c 10 \
-a "8192" \
-o \
-f 12092 \
-p h \
-s 27500 \
| jpcam -p 8719 -l + >\
/reiser/video/in/vie-$serial_number-all-pids.ts

/bin/echo "updating serial number"
let serial_number=serial_number+1
/bin/echo $serial_number > /reiser/video/in/serial.txt


Monitor this file with one language audio while recording:
cat /reiser/video/in/vie-457-all-pids.ts | ts2pes 4416 4417 | mplayer -cache 8192 -vop pp=0x20000 -


This shows hows how to call xdip from crontab:
As root do:
crontab -l > crtab
edit crtab so you have an entry that looks like this:

# each day at 10AM GMT = 11 CET             need to start after they change source!
02      11      *       *       *       /usr/local/sbin/record-vie-open-access &
00      12      *       *       *       killall -KILL xdipo

then type
crontab crtab

crontab -l 
shows if your changes were accepted.


Here is the /usr/local/sbin/record-vie-open-access script I use, note the full pathnames!:
/usr/bin/killall -KILL xdipo

serial_number=`/bin/cat /reiser/video/in/serial.txt`
/bin/echo "serial_number=$serial_number"

# info from http://www.kingofsat.net, search for 'open access':
# Name  Country  Category
# Open Access 2 United Kingdom General

# Satellite Transponder Beam
# EuroBird 1 (28.5?E) D10 Steerable 1

# Standard Frequency Polarisation SR FEC NID TID
# DVB/MPEG2 11642.00 MHz Vertical 27500 2/3 0 2410

# SID   VPID Audio        PMT PCR  TXT
# 50152 2312 2318 English 259 2324 0

# Encryption(s) Packages
# Clear Sky Digital

# Extra information Last updated
# Channel properties updated 2005-01-26 23:39:51

xdipo \
-g "19 E" \
-c 10 \
-a "2312 2318" \
-o \
-l /reiser/video/in/vie-open-access-$serial_number-bit-errors.txt \
-f 11642.00 \
-p v \
-s 27500 \
> /reiser/video/in/vie-open-access-$serial_number-all-pids.ts

/bin/echo "updating serial number"
let serial_number=serial_number+1
/bin/echo $serial_number > /reiser/video/in/serial.txt

exit


So this automatically record the 'open access' channel every morning from 11 to 12 my local (CET) time.
In the UK that would be an hour earlier in crontab!

Of cause you can keep xdipo running in GUI mode and set a 'daily' timer in the timers form too.

For a practical example of how I use xdipo look here:
http://panteltje.com/panteltje/dvd/show

This allows you to simply type
show ard
show zdf
etc etc
And you can use voice control by adding these commands to for example perlbox-voice.


