/*
         xdipo copyright Jan Panteltje 2005 and later.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

                                  /* SET TABS TO 4 TO READ THIS SOURCE */

#ifndef _XDIPO_PROTO_H_
#define _XDIPO_PROTO_H_


extern int re_enable_timer(struct timer * pa);
extern int close_output_files();
extern int open_output_files();
extern int set_record_button(int state);
extern int get_frontend_status();
extern int user_warning_dvr_buffer_size(int gui_flag);
extern int enable_controls(int mode);
extern int test_for_open_forms(int *some_form_open_flag);
extern int select_stream(int browser_line);
extern int satellite_name_to_browser_line(char *name, int *line);
extern int save_setting(char *type, char *string);
extern char *load_setting(char *type);
extern int save_fontsizes();
extern int load_fontsizes();
extern int save_general_settings();
extern int load_general_settings();
extern char *expand_tabs(char *text, int tabsize);
extern int weekday_to_digit(char *weekday_str);
extern int integer_to_fontsize(int fontsize);
extern int get_this_time(\
	time_t this_time,
	char *weekday,
	char *month,
	int *monthday,
	int *hour,
	int *minute,
	int *second,
	int *year
	);
extern int month_to_digit(char *month_str);

extern void timer_form_directory_input_field_cb(FL_OBJECT *ob, long data);
extern void timer_form_start_year_input_field_cb(FL_OBJECT *ob, long data);
extern void timer_form_start_month_input_field_cb(FL_OBJECT *ob, long data);
extern void timer_form_start_day_input_field_cb(FL_OBJECT *ob, long data);
extern void timer_form_start_hour_input_field_cb(FL_OBJECT *ob, long data);
extern void timer_form_start_minute_input_field_cb(FL_OBJECT *ob, long data);
extern void timer_form_length_input_field_cb(FL_OBJECT *ob, long data);
extern void timer_form_stop_year_input_field_cb(FL_OBJECT *ob, long data);
extern void timer_form_stop_month_input_field_cb(FL_OBJECT *ob, long data);
extern void timer_form_stop_day_input_field_cb(FL_OBJECT *ob, long data);
extern void timer_form_stop_hour_input_field_cb(FL_OBJECT *ob, long data);
extern void timer_form_stop_minute_input_field_cb(FL_OBJECT *ob, long data);
extern void timer_form_browser_cb(FL_OBJECT *ob, long data);
extern void timer_form_browser_double_cb(FL_OBJECT *ob, long data);
extern void timer_form_delete_button_cb(FL_OBJECT *ob, long data);
extern void timer_form_daily_button_cb(FL_OBJECT *ob, long data);
extern void timer_form_work_days_button_cb(FL_OBJECT *ob, long data);
extern void timer_form_weekly_button_cb(FL_OBJECT *ob, long data);
extern void timer_form_fontsize_up_button_cb(FL_OBJECT *ob, long data);
extern void timer_form_fontsize_down_button_cb(FL_OBJECT *ob, long data);
extern void timer_form_cancel_button_cb(FL_OBJECT *ob, long data);
extern void timer_form_accept_button_cb(FL_OBJECT *ob, long data);

extern char *get_selected_program_definition(int line);
extern struct timer *lookup_timer(char *name);
extern struct timer *install_timer_at_end_of_list(char *name);
extern int delete_timer(char *name);/* delete entry from double linked list */
extern int delete_all_timers();/* delete all entries from table */
extern int sort_timers();
extern int test_timer_overlap();
extern int load_timers();
extern int save_timers();
extern int show_timer_form();
extern int show_timers(int position);
extern char *line_to_timer(int line);
extern int timer_to_line(char *name, int *line);
extern int swap_timer_position(struct timer *ptop, struct timer *pbottom);
extern int add_timer_to_list(int line);
extern int inputs_to_timer(struct timer *pa, int update_length_field_flag);
extern int timer_to_inputs(struct timer *pa);
extern int pa_to_timer_line(struct timer *pt, int *timer_line);
extern struct timer *timer_line_to_pa(int line);
extern int delete_timer_pa(struct timer *pt);
extern int process_timers();
extern int timer_start_recording(struct timer *pt);
extern int timer_stop_recording();
extern int clear_timer_form();
extern int create_filename(char *program, struct timer *pa);
extern int update_time_and_filename(struct timer *pa);
extern int set_weekday_output(struct timer *pa);
extern int set_timer_length_input(int length);
extern char *get_selected_program_definition(int line);
extern void main_form_recorder_menu_cb(FL_OBJECT *ob, long data);
extern int parse_pids_string(char *string);
extern void main_form_pids_input_field_cb(FL_OBJECT *ob, long data);
extern void main_form_seek_slider_cb(FL_OBJECT *ob, long data);
extern int get_free_disk_space(char *dir, int *megabytes, int *percentage);
extern void main_form_record_button_cb(FL_OBJECT *ob, long data);
extern void main_form_satellite_name_input_field_cb(FL_OBJECT *ob, long data);
extern int recalculate_and_fill_in_fields();
extern int load_local_position();
extern int calculate_angle_and_elevation(\
	double longitude, double latitude, double satellite_position, double *angle, double *elevation);
extern void main_form_satellite_location_input_field_cb(FL_OBJECT *ob, long data);
extern void main_form_longitude_input_field_cb(FL_OBJECT *ob, long data);
extern void main_form_latitude_input_field_cb(FL_OBJECT *ob, long data); 
extern void main_form_angle_down_button_cb(FL_OBJECT *ob, long data);
extern void main_form_angle_up_button_cb(FL_OBJECT *ob, long data); 
extern int goto_angular_position(char *position);
extern void main_form_toggle_goto_angle_sattelite_button_cb(FL_OBJECT *ob, long data);
extern void main_form_angle_input_field_cb(FL_OBJECT *ob, long data);
extern int add_program_in_position();
extern void main_form_add_stream_button_cb(FL_OBJECT *ob, long data);
extern void main_form_delete_stream_button_cb(FL_OBJECT *ob, long data);
extern void main_form_signal_strength_slider_cb(FL_OBJECT *ob, long data);
extern struct program *lookup_program(char *name);
extern struct program *install_program_at_end_of_list(char *name);
extern int delete_program(char *name);
extern int delete_all_programs();
extern int save_programs();
extern int load_programs();
extern int swap_program_position(struct program *ptop, struct program *pbottom);
extern int sort_program_list();
extern int show_programs(int position);
extern int select_program(int program);
extern void main_form_stream_browser_cb(FL_OBJECT *ob, long data);
extern void main_form_stream_browser_double_cb(FL_OBJECT *ob, long data);
extern void main_form_installer_button_cb(FL_OBJECT *ob, long data);
extern void set_ts_filt(int fd, uint16_t pid, dmx_pes_type_t pestype);
extern void main_form_frequency_input_field_cb(FL_OBJECT *ob, long data);
extern void main_form_polarization_field_cb(FL_OBJECT *ob, long data);
extern void main_form_symbolrate_input_field_cb(FL_OBJECT *ob, long data);
extern void main_form_search_input_field_cb(FL_OBJECT *ob, long data);
extern int print_status();
extern int beep(int duration, int freq);
extern int sbeep(int milliseconds, int freq);
extern int beep_freq(int freq);
extern void beep_on();
extern void beep_off();
extern void main_form_signal_strength_indicator_cb(FL_OBJECT *ob, long data);
extern void main_form_beep_button_cb(FL_OBJECT *ob, long data);
extern int show_installer_commands_form();
extern int send_diseqc_command(int *data, int length);

extern void installer_commands_form_satellite_number_input_field_cb(FL_OBJECT *ob, long data);
extern void installer_commands_form_recalculate_param1_input_field_cb(FL_OBJECT *ob, long data);
extern void installer_commands_form_recalculate_param2_input_field_cb(FL_OBJECT *ob, long data);
extern void installer_commands_form_start_motor_driving_west_button_cb(FL_OBJECT *ob, long data);
extern void installer_commands_form_halt_motor_button_cb(FL_OBJECT *ob, long data);
extern void installer_commands_form_start_motor_driving_east_button_cb(FL_OBJECT *ob, long data);
extern void installer_commands_form_set_west_limit_button_cb(FL_OBJECT *ob, long data);
extern void installer_commands_form_disable_limits_button_cb(FL_OBJECT *ob, long data);
extern void installer_commands_form_set_east_limit_button_cb(FL_OBJECT *ob, long data);
extern void installer_commands_form_goto_reference_position_button_cb(FL_OBJECT *ob, long data);
extern void installer_commands_form_enable_limits_button_cb(FL_OBJECT *ob, long data);
extern void installer_commands_form_recalculate_positions_button_cb(FL_OBJECT *ob, long data);
extern void installer_commands_form_close_button_cb(FL_OBJECT *ob, long data);

extern void main_form_time_value_input_field_cb(FL_OBJECT *ob, long data);
extern void main_form_step_value_input_field_cb(FL_OBJECT *ob, long data);
extern void main_form_satellite_number_input_field_cb(FL_OBJECT *ob, long data);
extern void main_form_nudge_motor_west_button_cb(FL_OBJECT *ob, long data);
extern void main_form_nudge_motor_east_button_cb(FL_OBJECT *ob, long data);
extern void main_form_nudge_tilt_motor_up_button_cb(FL_OBJECT *ob, long data);
extern void main_form_nudge_tilt_motor_down_button_cb(FL_OBJECT *ob, long data);
extern void main_form_increase_nudge_size_button_cb(FL_OBJECT *ob, long data);
extern void main_form_decrease_nudge_size_button_cb(FL_OBJECT *ob, long data);
extern void main_form_toggle_step_timed_mode_button_cb(FL_OBJECT *ob, long data);
extern void main_form_store_present_satellite_number_button_cb(FL_OBJECT *ob, long data);
extern void main_form_goto_button_cb(FL_OBJECT *ob, long data);
extern void main_form_increment_satellite_number_button_cb(FL_OBJECT *ob, long data);
extern void main_form_decrement_satellite_number_button_cb(FL_OBJECT *ob, long data);
extern char *strsave(char *s);
extern int readline(FILE *file, char *contents);
extern int integer_to_fontsize(int fontsize);
extern int ogettime(
	char *weekday,
	char *month,
	int *monthday,
	int *hour,
	int *minute,
	int *second,
	int *year
	);
extern char *get_universal_time_as_string();
extern int idle_cb(XEvent *ev, void *data);
extern void installer_commands_form_cancel_button_cb(FL_OBJECT *ob, long data);
extern void installer_commands_form_accept_button_cb(FL_OBJECT *ob, long data);
extern void installer_commands_form_fontsize_down_button_cb(FL_OBJECT *ob, long data);
extern void installer_commands_form_fontsize_up_button_cb(FL_OBJECT *ob, long data);
extern void main_form_fontsize_down_button_cb(FL_OBJECT *ob, long data);
extern void main_form_fontsize_up_button_cb(FL_OBJECT *ob, long data);
extern void main_form_exit_switch_cb(FL_OBJECT *ob, long data);
extern void main_form_file_menu_cb(FL_OBJECT *ob, long data);
extern int jpinfo_init();
extern int process(int input_packets, FILE *output_ptr);
extern int search_and_select_satellite();
extern int search_in_for(char *database, char *data, int case_sensitive);
extern char *strstr_case_insensitive(char *s, char *t);
extern void main_form_search_button_cb(FL_OBJECT *ob, long data);
extern void main_form_case_sensitive_button_cb(FL_OBJECT *ob, long data);
extern int save_search_settings();
extern int load_search_settings();
extern void main_form_fontsize_up_button_cb(FL_OBJECT *ob, long data);
extern void main_form_fontsize_down_button_cb(FL_OBJECT *ob, long data);

#endif /* _XDIPO_PROTO_H_ */

